reset;
set GasN := 1..20;  #Ȼڵ
set GasN_GasStation within GasN ; #װõڵ
set GasN_Compressor within GasN ;  #ѹվɽڵ

param Max_F_GS { GasN_GasStation };
param Min_F_GS { GasN_GasStation };
param value_gas := 160 ;  #Ȼ۸񣬵λk$/Mm3
param b_GasGen := 0.0045 ; #ȼתϵ
param Max_GasLoad { GasN } ;
param F_Load {m in GasN}  =  Max_GasLoad[m] ; #Ȼ
param k {GasN, GasN} ;
param Min_Pre {GasN};
param Max_Pre {GasN};

var F_GS { GasN_GasStation } >= 0;
var F_Comp { GasN_Compressor} >= 0 ;
var F_Pipe { GasN, GasN };
var Pressure {m in GasN}  >= Min_Pre[m] , <= Max_Pre[m] ;

### Objective ###
minimize GasCost :
         sum {m in GasN_GasStation }  F_GS[m] * value_gas  ;

### Constraints ###
subj to GasFlow_all {m in GasN } :
        sum { n in GasN_GasStation: n = m } F_GS[n] -
        sum { n in GasN_Compressor: n = m } F_Comp[n] - F_Load[m] = 
        sum { n in GasN : m <> n } F_Pipe[m,n] ;  
          
subj to GasFlow_pipe {m in GasN, n in GasN : m <> n}:
        F_Pipe[m,n] =  if ( m = 8 and n = 9 )  then ( F_Comp[m] / ( 8078*0.0225 * b_GasGen) )
                         else (  if ( m = 9 and n = 8 ) then ( - F_Pipe[n,m] ) 
                                 else ( if ( m = 17 and n = 18 ) then ( F_Comp[m] / ( 8078*0.0435 * b_GasGen ) ) 
                                        else ( if ( m = 18 and n = 17 ) then ( - F_Pipe[n,m]  )
                                               else (          if Pressure[m] -  Pressure[n] > 0 then (  k[m,n] * sqrt ( Pressure[m] * Pressure[m] - 
                                                                                                                              Pressure[n] * Pressure[n] ) )
                                                                else ( if Pressure[m] -  Pressure[n] = 0 then  ( 0 ) 
                                                                       else ( - k[n,m] * sqrt( Pressure[n] * Pressure[n] -  Pressure[m] * Pressure[m])
                                                                            )
                                                                      )
                                                              
                                                     )
                                             ) 
                                       ) 
                              ) ;                            
subj to Pre_Comp {m in GasN_Compressor} :
        Pressure[m+1] = if m = 8 then ( Pressure[m] * 1.1 ) else ( Pressure[m] * 1.2 ) ;  
                           
subj to UpLimit_F_GS {m in GasN_GasStation} :
        F_GS[m] <= Max_F_GS[m] ; 
subj to DownLimit_F_GS {m in GasN_GasStation} :
        F_GS[m] >= Min_F_GS[m] ;   